import { arePathsMatch } from '@j.u.p.iter/node-utils';
import { createElement, Component } from 'react';

var createRouteFilter = function (pathsWithDisabledScroll) { return function (pathname) {
    return pathsWithDisabledScroll.some(function (path) { return arePathsMatch(pathname, path); });
}; };
var previousAndCurrentPathsDisabledFromScroll = function (paths) {
    var isPathDisabledFromScroll = createRouteFilter(paths);
    return function (prevPathname, newPathname) {
        return isPathDisabledFromScroll(prevPathname) &&
            isPathDisabledFromScroll(newPathname);
    };
};

/*! *****************************************************************************
Copyright (c) Microsoft Corporation. All rights reserved.
Licensed under the Apache License, Version 2.0 (the "License"); you may not use
this file except in compliance with the License. You may obtain a copy of the
License at http://www.apache.org/licenses/LICENSE-2.0

THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
MERCHANTABLITY OR NON-INFRINGEMENT.

See the Apache Version 2.0 License for specific language governing permissions
and limitations under the License.
***************************************************************************** */
/* global Reflect, Promise */

var extendStatics = function(d, b) {
    extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return extendStatics(d, b);
};

function __extends(d, b) {
    extendStatics(d, b);
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
}

var __assign = function() {
    __assign = Object.assign || function __assign(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};

var withScrollHocFactory = function (disableScrollStrategy) {
    return function (WrappedComponent) {
        return /** @class */ (function (_super) {
            __extends(class_1, _super);
            function class_1() {
                return _super !== null && _super.apply(this, arguments) || this;
            }
            class_1.prototype.componentDidUpdate = function (_a) {
                var prevPathname = _a.location.pathname;
                var newPathname = this.props.location.pathname;
                var isScrollDisabled = disableScrollStrategy;
                if (!isScrollDisabled(prevPathname, newPathname)) {
                    window.scrollTo(0, 0);
                }
            };
            class_1.prototype.render = function () {
                return createElement(WrappedComponent, __assign({}, this.props));
            };
            return class_1;
        }(Component));
    };
};

var withScrollHoc = function (paths) {
    return withScrollHocFactory(previousAndCurrentPathsDisabledFromScroll(paths));
};

export { withScrollHoc, withScrollHocFactory };
